// Code generated by mockery v2.20.0. DO NOT EDIT.

package mockclients

import (
	context "context"

	mock "github.com/stretchr/testify/mock"

	types "gitlab.com/infor-cloud/martian-cloud/tharsis/tharsis-sdk-go/pkg/types"
)

// TerraformProvider is an autogenerated mock type for the TerraformProvider type
type TerraformProvider struct {
	mock.Mock
}

// CreateProvider provides a mock function with given fields: ctx, input
func (_m *TerraformProvider) CreateProvider(ctx context.Context, input *types.CreateTerraformProviderInput) (*types.TerraformProvider, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.TerraformProvider
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.CreateTerraformProviderInput) (*types.TerraformProvider, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.CreateTerraformProviderInput) *types.TerraformProvider); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.TerraformProvider)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.CreateTerraformProviderInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// DeleteProvider provides a mock function with given fields: ctx, input
func (_m *TerraformProvider) DeleteProvider(ctx context.Context, input *types.DeleteTerraformProviderInput) (*types.TerraformProvider, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.TerraformProvider
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.DeleteTerraformProviderInput) (*types.TerraformProvider, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.DeleteTerraformProviderInput) *types.TerraformProvider); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.TerraformProvider)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.DeleteTerraformProviderInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetProvider provides a mock function with given fields: ctx, input
func (_m *TerraformProvider) GetProvider(ctx context.Context, input *types.GetTerraformProviderInput) (*types.TerraformProvider, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.TerraformProvider
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetTerraformProviderInput) (*types.TerraformProvider, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetTerraformProviderInput) *types.TerraformProvider); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.TerraformProvider)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.GetTerraformProviderInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// UpdateProvider provides a mock function with given fields: ctx, input
func (_m *TerraformProvider) UpdateProvider(ctx context.Context, input *types.UpdateTerraformProviderInput) (*types.TerraformProvider, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.TerraformProvider
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.UpdateTerraformProviderInput) (*types.TerraformProvider, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.UpdateTerraformProviderInput) *types.TerraformProvider); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.TerraformProvider)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.UpdateTerraformProviderInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

type mockConstructorTestingTNewTerraformProvider interface {
	mock.TestingT
	Cleanup(func())
}

// NewTerraformProvider creates a new instance of TerraformProvider. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
func NewTerraformProvider(t mockConstructorTestingTNewTerraformProvider) *TerraformProvider {
	mock := &TerraformProvider{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
